package ROTool::Client;
use strict;
use ROTool;
use vars qw(@ISA);

@ISA = qw( ROTool );

sub is_morph{
    # not a method

    # Please implement for each protocol, 
    # and add entry into ROTool::recv();
}

sub new{
    # please implement for each protocol if need.
    my $self  = shift;
    my $class;
    if(ref($self)){
	$class = ref($self);
    }else{
	$class = $self;
	$self = shift;
    }
    $self->{"param"} = {};
    $self->{"timer"} = {};
    $self->{"state"} = {};
    $self->{"timer"}->{"shutdown"}= &ROTool::timeout();
    $self->{"param"}->{"message"} = "";
    $self->timestamp();
    &ROTool::printlog(1," morph [$self->{oid}] into $class\n");
    return bless $self , $class;
}

sub is_client{
    return 1;
}

sub is_server{
    return 0;
}

sub recv{
    my $self = shift;

    my $sock = $self->{"sock"};
    $sock->clearerr();
    my($len,$len_total) = 0;

    $len = $sock->sysread($self->{"buf"},8192,length($self->{"buf"}));

    return 0 if(defined $len && $len == 0);
    return -1 if ($sock->error());
    $self->{"timer"}->{"shutdown"}= &ROTool::timeout() if($len);
    
    return 1;
    # please implement for each protocol
}

sub send{
    my $self = shift;
    # please implement for each protocol
}

sub shutdown{
    # please implement for each protocol if need
    my $self = shift;
    my($selecter) = @_;

    my $sock = $self->{"sock"};
    if($self->{"Message_lasting"}){
	&ROTool::UA_unregist($self);
	&ROTool::client_unregist($self);
	&ROTool::printlog(1," unkeepmsg[$self->{oid}]\n");
    }elsif($self->is_keep_message()){
	&ROTool::sock_unregist($self);
	$selecter->remove($sock);
	$sock->shutdown(2);
	$self->keep_message();
	$self->{timer}->{shutdown} = &ROTool::keeptime();
	&ROTool::printlog(1," shutdown and keepmsg[$self->{oid}]\n");
    }else{
	$self->{timer}->{shutdown} = 0;
	&ROTool::sock_unregist($self);
	$selecter->remove($sock);
	$sock->shutdown(2);
	&ROTool::UA_unregist($self);
	&ROTool::client_unregist($self);
	&ROTool::printlog(1," shutdown [$self->{oid}]\n");
    }

}

sub timestamp{
    my($self) = shift;
    $self->{"param"}->{"time"} = 
	sprintf("%02d:%02d", (localtime())[2,1]);
}

sub keep_message{
    my $self = shift;
    $self->{"param"}->{"name"}  = "--";
    $self->{"param"}->{"area"}  = "no connect";
    $self->{"param"}->{"lv"}    = "--/--/--";
    $self->{"param"}->{"server"}= "--";
    $self->{"param"}->{"hp"}    = 0;
    $self->{"param"}->{"hpmax"} = 0;
    $self->{"param"}->{"SP"}    = 0;
    $self->{"param"}->{"MaxSP"} = 0;
    $self->{"Message_lasting"}  = 1;

}

sub checktimer{
    my $self = shift;
    my($selecter) = @_;

    my @result;
    $self->{timer}->{shutdown}--;
    if($self->{timer}->{shutdown} == 0){
	$self->shutdown($selecter);
    }
}

sub is_keep_message{
    my $self = shift;
    return 0 if($self->{"Message_lasting"});
    return 1 if($self->{"param"}->{"message"}
                =~ /^(\(|\x81\x69).*?(\)|\x81\x6a)$/);
    return 0;
}

__END__

=head1 NAME

ROTool::Client - base module of ROTool clients.

=head1 DESCRIPTION
    
C<ROTool::Client> is base module of ROTool clients.

B<NOTICE> : Do not use C<ROTool::Client> as module or class.
C<ROTool::Client> is only super module of ROTool clients module.

=head1 STYLE GUIDELINE

