package RO_GPS;
#$Id: RO_GPS.pm,v 1.1 2002/10/23 07:14:13 white Exp $

my $SERVER_HEADER = "RO-GPS/S04";
my $CLIENT_HEADER = "RO-GPS/C04";
my $APPRI_VER     = "RO_GPS.pm.a100";

sub version{
    return $APPRI_VER;
}

my $LOG_LEVEL;
sub set_LOG_LEVEL{
    ($LOG_LEVEL) = @_;
}

sub parse_serv_msg{
    my($msg) = @_;
    my(@clients);
    $msg =~ s/\002$//g;
    @_ = split(/\001/,$msg);
    splice(@_,0,1);
    my $records = shift(@_);
    while(@_){
	$hash = {};
	@$hash{"APPRI_VER","ID","serv","name","place","HP","MaxHP","SP","MaxSP","Lv","Mes"} = splice(@_,0,11);
	$hash->{"ID"}    =~ s/^"(.*)"$/$1/g;
	$hash->{"name"}  =~ s/^"(.*)"$/$1/g;
	$hash->{"place"} =~ s/^"(.*)"$/$1/g;
	$hash->{"Lv"}    =~ s/^"(.*)"$/$1/g;
	$hash->{"Mes"}   =~ s/^"(.*)"$/$1/g;
	push(@clients,$hash);
    }
    return @clients;
}

sub make_serv_msg{
    my(%clients) = @_;
    my $msg,@msg;

    # header
    push(@msg,($SERVER_HEADER,scalar(keys %clients)));

    foreach(values %clients){
	my %hash = %{$_{state}};
	$hash{"ID"}    = qq{"$hash{ID}"};
	$hash{"name"}  = qq{"$hash{name}"};
	$hash{"place"} = qq{"$hash{place}"};
	$hash{"Lv"}    = qq{"$hash{Lv}"};
	$hash{"Mes"}   = qq{"$hash{Mes}"};
	push(@msg,@hash{"APPRI_VER","ID","serv","name","place",
			"HP","MaxHP","SP","MaxSP","Lv","Mes"});
    }
    $msg = join("\001",@msg)."\002";
    undef(@msg);
    return $msg;
}

sub make_client_msg{
    my(%hash) = @_;
    my $msg;

    $hash{"ID"}    = qq{"$hash{ID}"};
    $hash{"name"}  = qq{"$hash{name}"};
    $hash{"place"} = qq{"$hash{place}"};
    $hash{"Lv"}    = qq{"$hash{Lv}"};
    $hash{"Mes"}    = qq{"$hash{Mes}"};
    @_ = ($CLIENT_HEADER);
    push(@_,@hash{"APPRI_VER","ID","serv","name","place",
		  "HP","MaxHP","SP","MaxSP","Lv","Mes"});
    $msg = join("\001",@_)."\002";
    return $msg;
}

sub client_toString{
    my(%hash) = @_;
    return sprintf("%8s|%6s|%8s|%10s|%4d/%4d|%4d/%4d|%10s|%-s\n",
		   @hash{"ID","serv","name","place",
			 "HP","MaxHP","SP","MaxSP","Lv","Mes"});
}

sub client_Labels{
    return sprintf("%-8s|%-6s|%-8s|%-10s|%-9s|%-9s|%-10s|%-s\n",
		   "ID","serv","name","place","HP","SP","Lv","Mes");
}
1;
